<%@ page import="java.text.MessageFormat"%>
<%@ page import="com.sas.oprisk.monitor.web.dimension.*" %>
<%@ page import="com.sas.oprisk.server.cpb.uiDefType.dimensions.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.DateTimeUtils" %>
<%@ page import="com.sas.oprisk.framework.server.objects.FieldDescriptor" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ include file="/tiles/taglibs.jsp" %>
<%    
   java.util.Locale locale = request.getLocale();
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final DimensionNodeModel model = (DimensionNodeModel)request.getAttribute("model");
   final String dimValue = model.getNode().getDimension().getValue();
	
	final String actionPath = DimensionNodeAction.getActionPath(model.getNode());
	final String saveActionPath = DimensionNodeAction.getSaveActionPath(model.getNode());
	
	boolean changeReasonRequired = ConfigDataProperties.isChangeReasonRequired();
	
	final DimensionNode node = model.getNode();
	String deleteConfirmMsgPattern = bundle.getString("DimensionNode.deleteWarning.fmt.txt");
	Object[] args = {node.getDimensionName(locale), node.getName(locale)};
	String deleteConfirmMsg = ParsingUtils.escape(MessageFormat.format(deleteConfirmMsgPattern, args));
%>
<mon:Page template="details">

<mon:Head>
<script type="text/javascript">

function monitorInit() {
	initNSMenu();
	
	<c:if test="${model.readOnly}">
		var f = document.forms.<c:out value="${model.formName}"/>;
	
		// disable all other form fields and buttons
		for(i = 0; i < f.elements.length; i++) {
	  		if (f.elements[i].type != "hidden" &&
				 f.elements[i].name.substring(0,12) != "actionButton" &&
				 f.elements[i].name != "showInheritedMappings" &&
				 f.elements[i].name.substring(0,3) != "sm.")
			{
				f.elements[i].disabled = true;
			}
		}
	</c:if>
}

function doDim(method, anchor) {
   var f = document.forms.<c:out value="${model.formName}"/>;
   f.action = "<%= request.getContextPath() %>/Dimension.do";
   if (anchor) {
	   f.action = f.action + "#" + anchor;
   }
   f.elements["method"].value = method;
   f.submit();
}

function doDimNode(method, anchor, queryString) {
   var f = document.forms.<c:out value="${model.formName}"/>;
   
   <% if (!changeReasonRequired) { %>
   
   if (method == 'delete' && !confirm(unescape('<%= deleteConfirmMsg %>'))) {
      return;
   }
   
   <% } %>
   
   if (queryString) {
      f.action = f.action + "?" + queryString;
   }
   if (anchor) {
	   f.action = f.action + "#" + anchor;
   }
   f.elements["method"].value = method;
   f.submit();
}

function doSave() {
   var f = document.forms.<c:out value="${model.formName}"/>;
   f.action = "<%= request.getContextPath() + saveActionPath %>.do";
   f.submit();
}

function forward(path, refreshMethod, anchor) {
   var method = "forward";
   var queryString = "&path=" + escape(path);
   if (refreshMethod) {
      queryString += "&rm=" + refreshMethod;
   }
  
   doDimNode(method, anchor, queryString);
}

function selectParent(id, name, node) {
   var f = document.forms.<c:out value="${model.formName}"/>;
   f.parentHandle.value = id;
}

</script>
</mon:Head>

<mon:Body>

<mon:form action="<%= actionPath %>">

<mon:ToolBar>
<!-- buttons -->

   <c:if test="${model.readOnly}">
      <c:if test="${model.canEdit}">
         <input type="button" class="button" name="actionButtonEdit"
           onmouseover="this.className='button buttonRollover'"
           onmouseout="this.className='button'"
           value="<fmt:message key="application.button.edit.txt" />"
           onclick="doDimNode('edit')"/>
      </c:if>
      <c:if test="${model.canSplit}">
         <input type="button" class="button" name="actionButtonSplit"
            onmouseover="this.className='button buttonRollover'"
            onmouseout="this.className='button'"
            value="<fmt:message key='splitButton.txt' />" 
            onclick="doDimNode('split')" />
      </c:if>
      <c:if test="${model.canMerge}">
         <input type="button" class="button" name="actionButtonMerge"
            onmouseover="this.className='button buttonRollover'"
            onmouseout="this.className='button'"
            value="<fmt:message key='mergeButton.txt' />" 
            onclick="doDim('selectMergeDestination')" />
      </c:if>
      <c:if test="${model.canMove}">
         <input type="button" class="button" name="actionButtonMove"
            onmouseover="this.className='button buttonRollover'"
            onmouseout="this.className='button'"
            value="<fmt:message key='moveButton.txt' />" 
            onclick="doDimNode('prepareToMove')" />
      </c:if>
      <c:if test="${model.canDelete}">
         <input type="button" class="button" name="actionButtonDelete"
            onmouseover="this.className='button buttonRollover'"
            onmouseout="this.className='button'"
            value="<fmt:message key='deleteButton.txt' />" 
            onclick="doDimNode('delete')" />
      </c:if>
      <input type="button" class="button" name="actionButtonCancel"
         onmouseover="this.className='button buttonRollover'"
         onmouseout="this.className='button'"
         value="<fmt:message key="application.button.done.txt" />"
         onclick="breadcrumb('<c:out value="${model.formName}"/>', 2);"/>
   </c:if>
   <c:if test="${!model.readOnly}">
      <input type="button" class="button" name="actionButtonSave"
         onmouseover="this.className='button buttonRollover'"
         onmouseout="this.className='button'"
         value="<fmt:message key="application.button.save.txt" />"
         onclick="doSave()"/>
      <c:if test="${model.node.fresh}">
         <input type="button" class="button" name="actionButtonCancel"
            onmouseover="this.className='button buttonRollover'"
            onmouseout="this.className='button'"
            value="<fmt:message key="application.button.cancel.txt" />"
            onclick="breadcrumb('<c:out value="${model.formName}"/>');"/>
      </c:if>
      <c:if test="${not model.node.fresh}">
         <input type="button" class="button" name="actionButtonCancel"
            onmouseover="this.className='button buttonRollover'"
            onmouseout="this.className='button'"
            value="<fmt:message key="application.button.cancel.txt" />"
            onclick="doDimNode('view')"/>
      </c:if>
   </c:if>

</mon:ToolBar>

<mon:Content>

   <input type="hidden" name="method" />
   <input type="hidden" name="modelIsReadOnly" value="<%= model.isReadOnly() %>"/>
   <input type="hidden" name="dimension" value="<c:out value="${model.dimensionNodeClassName}"/>" />
   <html:hidden property='<%= model.getFieldProperty("key") %>' />
   <html:hidden property="handle" />
   <html:hidden property="levelNo" />
   <html:hidden property="dimensionValue" />
   <mon:Hidden name="<%= DimensionNodeUIDefinitionType.PARAM_PARENT_HANDLE %>" />
   
   <cpb:screen screenID="<%= dimValue %>" readOnly="<%= model.isReadOnly() %>" />

</mon:Content>

</mon:form>

</mon:Body>

</mon:Page>